/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBνCDC䉞pǗ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "host_cdc_task.h"
#include "modules/usb/host_chap9/usb_host_task.h"
#include "modules/usb/host_chap9/usb_host_enum.h"
#include "lib_mcu/usb/usb_drv.h"
#ifdef CDC_USE_UART
  #include "lib_mcu/uart/uart_lib.h"
#endif

//_____ ϸ ________________________________________________________________

#ifndef LOG_STR_CODE
#define LOG_STR_CODE(str)
#else
U8 code log_cdc_connect[]="CDC Connected";
#endif

//_____ ` _______________________________________________________________

//_____ 錾 _______________________________________________________________

U8 cdc_connected;
U8 cdc_interface_comm;
U8 cdc_cpt_sof;

U8 pipe_cdc_comm_int;
U8 pipe_cdc_data_bulkin;
U8 pipe_cdc_data_bulkout;

U8 tx_counter;
U8 rx_counter;
U8 cdc_stream_out_array[CDC_STREAM_OUT_SIZE];
U8 cdc_stream_in_array[CDC_STREAM_IN_SIZE];

//!@brief ̊֐USBνCDCp܂B
//!
void host_cdc_task_init (void)
{
#ifdef CDC_USE_UART
	uart_init();
#endif
	Leds_init();
	cdc_connected = 0;
	cdc_interface_comm = 0;
	Joy_init();
}

//! @brief ̊֐νCDCpǗ܂B
//!
void host_cdc_task (void)
{
	U8 i, ep;

	if(Is_host_ready())
	{
		if(Is_new_device_connection_event())
		{
			cdc_connected=0;
			for(i=0;i<Get_nb_supported_interface();i++)
			{
				// ް ̪
				if((Get_class(i)==CDC_DATA_CLASS) && (Get_subclass(i)==CDC_DATA_SUBCLASS) && (Get_protocol(i)==CDC_DATA_PROTOCOL))
				{
					cdc_connected=1;
					Host_enable_sof_interrupt();
					LOG_STR_CODE(log_cdc_connect);
					if(Is_ep_addr_in(Get_ep_addr(i,0)))
					{	// ͂ACDCްIN߲߂Ƒgݍ킹܂B
						pipe_cdc_data_bulkin = host_get_hwd_pipe_nb(Get_ep_addr(i,0));
						pipe_cdc_data_bulkout = host_get_hwd_pipe_nb(Get_ep_addr(i,1));
					}
					else
					{	// AtłB
						pipe_cdc_data_bulkin = host_get_hwd_pipe_nb(Get_ep_addr(i,1));
						pipe_cdc_data_bulkout = host_get_hwd_pipe_nb(Get_ep_addr(i,0));
					}
					Host_select_pipe(PIPE_CDC_DATA_IN);
					Host_continuous_in_mode();
					Host_unfreeze_pipe();
					break;
				}
				// Ǘ̪
#ifdef CDC_USE_MANAGEMENT_INTERFACE
				if(((Get_class(i)==CDC_COMM_CLASS) && (Get_subclass(i)==CDC_COMM_SUBCLASS) && (Get_protocol(i)==CDC_COMM_PROTOCOL))
	#ifdef CDC_USE_ACTIVE_SYNC_INTERFACE
				|| ((Get_class(i)==0xEF) && (Get_subclass(i)==0x01) && (Get_protocol(i)==0x01)) )	// ׽ ̪
	#else
				)
	#endif
				{
					cdc_interface_comm = i;	// ̪ԍi[
					pipe_cdc_comm_int = host_get_hwd_pipe_nb(Get_ep_addr(i,0));
					Host_select_pipe(PIPE_CDC_COMM);
					Host_continuous_in_mode();
					Host_unfreeze_pipe();
				}
#endif

#ifdef CDC_USE_SPECIFIC_VENDOR_INTERFACE	// CDCû悤ȓ苟Ҳ̪
				// 苟Ҳ̪1̲̪őSĂ(3)߲Ă܂݂܂B
				if((Get_class(i)==0xFF) && (Get_subclass(i)==0x00) && (Get_protocol(i)==0x00) && (Get_nb_ep(i)==3) )
				{
					cdc_connected=1;
					Host_enable_sof_interrupt();
					LOG_STR_CODE(log_cdc_connect);

					for( ep=0; ep<3; ep++)
					{
						if(TYPE_INTERRUPT == usb_tree.device[selected_device].interface[i].ep[ep].ep_type)
						{
							cdc_interface_comm = i;	// ̪ԍi[
							pipe_cdc_comm_int = host_get_hwd_pipe_nb(Get_ep_addr(i,ep));
							Host_select_pipe(PIPE_CDC_COMM);
							Host_continuous_in_mode();
							Host_unfreeze_pipe();
						}
						if(TYPE_BULK == usb_tree.device[selected_device].interface[i].ep[ep].ep_type)
						{
							if(Is_ep_addr_in(Get_ep_addr(i,ep)))
							{	// ͂ACDCްIN߲߂Ƒgݍ킹܂B
								pipe_cdc_data_bulkin = host_get_hwd_pipe_nb(Get_ep_addr(i,ep));
								Host_select_pipe(PIPE_CDC_DATA_IN);
								Host_continuous_in_mode();
								Host_unfreeze_pipe();
							}else{	// AtłB
								pipe_cdc_data_bulkout = host_get_hwd_pipe_nb(Get_ep_addr(i,ep));
							}
						}
					}
				}
#endif

			}
			// (CDCdl1.1 6.2.14߂ɏ])߰ĂJB
			usb_request.bmRequestType = USB_SETUP_SET_CLASS_INTER;
			usb_request.bRequest      = SETUP_CDC_SET_CONTROL_LINE_STATE;
			usb_request.wValue        = 0x03;	// ޯ1:رAޯ0:DTE݂邱ƂDCEɎB
			usb_request.wIndex        = 0;		// ̪ԍ
			usb_request.wLength       = 0;
			usb_request.uncomplete_read = FALSE;
			if( CONTROL_GOOD == host_send_control(0))
			{
				U8 u8_LineCoding[7];
				usb_request.bmRequestType = USB_SETUP_SET_CLASS_INTER;
				usb_request.bRequest      = SETUP_CDC_SET_LINE_CODING;
				usb_request.wValue        = 0;	// 0
				usb_request.wIndex        = 0;	// ̪ԍ
				usb_request.wLength       = 7;	// s\̂̑傫
				usb_request.uncomplete_read = FALSE;
				u8_LineCoding[0] = 0xFF&(BAUDRATE>>0);
				u8_LineCoding[1] = 0xFF&(BAUDRATE>>8);
				u8_LineCoding[2] = 0xFF&(BAUDRATE>>16);
				u8_LineCoding[3] = 0xFF&(BAUDRATE>>24);
				u8_LineCoding[4] = 0;	// 1~ޯ
				u8_LineCoding[5] = 0;	// èȂ
				u8_LineCoding[6] = 8;	// 8ް ޯ

				if( CONTROL_GOOD == host_send_control(u8_LineCoding))
				{
					Led1_on();
				}
			}
		}

		if(cdc_connected)
		{
			// ްɑ΂DATA_PIPE_IN
			// ************************************
			// 1  UART-USB`
			//   Mް͎IUART֑܂B
			// 2  W`
			//   Mް"cdc_stream_in_array[CDC_STREAM_IN_SIZE]"zɊi[̧ѳɂēǂނƂł܂B
			//   ̧ѳzǂގɂSɍs"rx_counter"ϐ0ɐݒ肵Ȃ΂Ȃ܂B
			//   IɔzĂrx_counter炵ĂȂ܂(͔zNł傤)B
			Host_select_pipe(PIPE_CDC_DATA_IN);
			if (Is_host_in_received() && (Is_host_stall()==FALSE))
			{
#ifdef CDC_USE_UART
				while (Host_data_length_U8() != 0)
				{
					uart_putchar(Host_read_byte());
				}
				Host_ack_in_received();		// ߲߂͋
				Host_send_in();				// ް󂯎鏀
#else
				while ((rx_counter != CDC_STREAM_IN_SIZE) && (Host_data_length_U8() != 0))
				{
					cdc_stream_in_array[rx_counter] = Host_read_byte();
					rx_counter++;
				}
				if (Host_data_length_U8() == 0)
				{
					Host_ack_in_received();	// ߲߂͋
					Host_send_in();			// ް󂯎鏀
				}
#endif
			}

			// DATA_PIPE_OUTԂőް
			// ********************************************
			// ׂް"cdc_stream_out_array[CDC_STREAM_OUT_SIZE]"zɊi[܂B
			// ްUART܂RAM(̧ѳ)̂ǂ炩疳֌Wɂė܂B
			// ް͈ȉ̎CDCu֑܂B
			//	- "cdc_pipe_out_usb_flush()"֐ĂԂƂɂĎgp҂v
			//	- Ԃo(CDC_NB_MS_BEFORE_FLUSH=OSF)
			//	- ɏՕt(tx_counter=CDC_STREAM_OUT_SIZE)

#ifdef CDC_USE_UART
			// USARTUSBɊi[ׂV޲Ă邩
			if (uart_test_hit() && (tx_counter != CDC_STREAM_OUT_SIZE))
			{
				cdc_stream_out_array[tx_counter] = uart_getchar();
				tx_counter++;
			}
#endif

			// ߲߈|KvƂ邩(ɏՕt܂͐Ԍo)
			if(((cdc_cpt_sof>=CDC_NB_MS_BEFORE_FLUSH) && (tx_counter!=0)) || (tx_counter == CDC_STREAM_OUT_SIZE))	// Ԓ߂ɂɏՕ|
			{
				cdc_cpt_sof=0;
				cdc_pipe_out_usb_flush();
			}

			// ėʒmɑ΂COMM_PIPE_IN
			// ************************************************
			Host_select_pipe(PIPE_CDC_COMM);
			if (Is_host_in_received())
			{
				// uɂđꂽʒmүނŏ
				// ʒmүނ͈ȉ̍\̎܂B:
				//  bmRequestType - bNotification - wValue - wIndex - wLength - Data (wLengthް̈޲ĐłB)

				//   - NETWORK_CONNECTION : uȯܰɐڑꂽƂ܂B
				//   - RESPONSE_AVAILABLE : uƂ܂(νėv҂)B
				//   - SERIAL_STATE : uUART̏Ԃ܂(ُAرȂM)B
				//   - Ȃ...

				// ...č...Pɺިݸ...
				Host_ack_in_received();
				Host_send_in();
			}
		}
	}

	// uؒf
	if(Is_device_disconnection_event())
	{
		Leds_off();
		cdc_connected=0;
		cdc_interface_comm = 0;
	}
}

//! ̊֐USBڰъJn荞ݻٰ݂s(1ms)cdc_cpt_sofv
//! 𑝂܂B
//! xԊǗɗLpłB
//!
void sof_action (void)
{
	cdc_cpt_sof++;
}

//! ̊֐͑MꎞɏՕɊi[ꂽް𑗂܂B
//! ̊֐͊ɏՕްȂꍇɂ͉s܂B
//!
void cdc_pipe_out_usb_flush (void)
{
	Host_select_pipe(PIPE_CDC_DATA_IN);		// (ٸ)IN͓Ȃ΂Ȃ炸AȂΑ(ٸ)OUT꓾܂B
	Host_freeze_pipe();
	if (PIPE_GOOD == host_send_data(PIPE_CDC_DATA_OUT, tx_counter, cdc_stream_out_array))
	{
		tx_counter = 0;						// ڰтȂꍇAɍĂюs܂(ް͎܂)B
	}
	Host_select_pipe(PIPE_CDC_DATA_IN);
	Host_unfreeze_pipe();
}
